# Hip (red sa prioritetom)
# https://docs.python.org/3.7/library/heapq.html
# Funkcije:
# * heapify – Konvertuje listu u hip u mestu.
# * heappush – Dodaje element u hip.
# * heappop – Izbacuje najmanji element iz hipa i vraca ga kao povratnu vrednost.
# * heapreplace – Zamenjuje koren hipa novom vrednoscu prosledjenoj funckiji.
import heapq

H = [21,1,45,78,3,5]
heapq.heapify(H)
print(H)
heapq.heappush(H,8)
print(H)

# Heapsort
def heapsort(iterable):
    h = []
    for value in iterable:
        heapq.heappush(h, value)
    return [heapq.heappop(h) for i in range(len(h))] 

print(heapsort([1, 3, 5, 7, 9, 2, 4, 6, 8, 0]))

# list comprehension
# [expression for item in iterable if condition]
l = [(i,j) for i in range(10) for j in range(10,20) if i + j < 25]
print(l)