class Robot:
    
    populacija = 0  # klasna promenljiva

    # konstruktor
    def __init__(self, name):
        self.name = name
        Robot.populacija += 1
        print(f"{self.name} je kreiran!")

    # destruktor
    def __del__(self):
        print(f"{self.name} se unistava!")
        Robot.populacija -= 1

    def oglasi_se(self):
        print(f"Zdravo, moje ime je {self.name}.")

    @classmethod
    def koliko(cls):
        print(f"Imamo {cls.populacija} aktivnih robota.")

    # postoji i @staticmethod dekorator, takve funkcije nemaju parametre
    # koriste se kada nije potrebno da metod pristupa atributima klase


droid1 = Robot("R2-D2")
droid1.oglasi_se()
Robot.koliko()

droid2 = Robot("C-3PO")
droid2.oglasi_se()
Robot.koliko()

print("\nRoboti rade posao ovde...\n")

print("Roboti su zavrsili posao. Obrisimo ih.")

del droid1
Robot.koliko()

del droid2
Robot.koliko()

