# Generatori

# sintaksna jednostavnost, lenja evaluacija, memorijska efikasnost
# svaki put kada se f-ja __next__() pozove nad generatorom izvrsavanje se nastavlja od prethodne yield naredbe sve do nailaska na sledecu
# kada nema vise yield naredbi ili se stigne do eksplicitne return naredbe podize se StopIteration

def Fibonacci():
    a, b = 0, 1
    while True:
        yield a
        a, b = b, a + b

f = Fibonacci()
for i in range(10):
    print(f, f.__next__())

def Fibonacci_limit(limit=10):
    a, b = 0, 1
    i = 0
    while i < limit:
        yield a
        a, b = b, a + b
        i += 1

for i in Fibonacci_limit(12):
    print(i)
