def square(x):
    return x ** 2

def translate(x):
    x -= 1
    return x

# kompozicija f-ja
print(square(translate(4)))


def foo(a, b, c, d=10):
    # lokalna f-ja (nested)
    x = 1
    def suma(a, b, c, x):
        return a + b + c + x

    return suma(a, b, c, x) * d

print(foo(2, -3, 4))

# Anonimna f-ja
cube = lambda x : x**3
print(cube(4))
print(cube)

# Primer f-je viseg reda (f-je su gradjani 1. reda: mogu biti argumenti ili povratne vrednosti drugih f-ja, mogu se dodeljivati promenljivama, mogu biti elementi kolekcija...)
def apply(l, func, factor):
    results = []

    for item in l:
        result = func(item, factor)
        results.append(result)

    return results

def multiply(x, factor):
    return x * factor

subtract = lambda x, factor: x - factor

l = [10, 4, -5, 1]

print(apply(l, multiply, 10))
print(apply(l, subtract, 5))
print(apply(l, lambda x, factor: x + factor, 20))
